#pragma once

/*
	This class is used for manage chat room in chat room list
*/


#include "ChatRoom.h"
#include "AutoLock.h"
#include <algorithm>

using namespace std;

class CChatRoomView;
class CChatRoomManager
{
	enum ChatRoomAction;
public:
	CChatRoomManager(CChatRoomView* pView)
	{
		m_pView = pView;
		m_listChatRoom.clear();
	}

	virtual ~CChatRoomManager(void)
	{
        m_pView = NULL;
	}

	bool Add(CChatRoom* pChatRoom);

	bool Remove(int nRoomID);

	bool Update(CChatRoom* pChatRoom, CChatRoomManager* pRoomManager);

	CChatRoom* GetChatRoom(int nRoomID);

	void NotifyView( CChatRoom* pChatRoom, ChatRoomAction Action );

	void NotifyView( int nRoomID, ChatRoomAction Action );
private:
	enum ChatRoomAction
	{
		AddAction = 0,
		RemoveAction,
		UpdateAction
	};

	typedef	list<CChatRoom*> ListChatRoom;
	typedef ListChatRoom::iterator ITListChatRoom;

	class CRoomValueFinder
	{
	public:
		CRoomValueFinder(CChatRoom*	pChatRoom) 
            : m_pChatRoom(pChatRoom)
            , m_nRoomID(-1)
            , m_bFindValue(false)
        {}
		CRoomValueFinder(int nRoomID) 
            : m_pChatRoom(NULL)
            , m_nRoomID(nRoomID)
            , m_bFindValue(true)
        {
        }
		bool operator ()(CChatRoom*	pChatRoom)
		{
			if(m_bFindValue)
			{
				return pChatRoom->m_nRoomID == m_nRoomID;
			}

			return pChatRoom->m_nRoomID == m_pChatRoom->m_nRoomID;
		}

	private:
		CChatRoom*	m_pChatRoom;
		int			m_nRoomID;
		bool		m_bFindValue;
	};

	CrSectionEx			m_csChatRoomList;
	ListChatRoom		m_listChatRoom;
	CChatRoomView*		m_pView;
};
